---
layout: layouts/exercise_base.njk
exercise: OOP - Inheritance
---

<p>Before submitting your solutions, make sure that <kbd>cppcheck</kbd>
  doesn't show any errors.
</p>

<ol>
  <li><strong>Bank Account</strong><br />
    Extend your bank account example from the
    <a href="../oop_intro/">introduction to OOP</a> exercise to contain
    additional account types. Do not touch the existing <code>Account</code>
    class. Instead, add new subclasses to cover the new requirements. Consider
    your original example open for extension but closed for modification.
    This is called the
    <a href="https://en.wikipedia.org/wiki/Open-closed_principle">
      open–closed principle (OCP)</a>. This principle is one of the five
    <a href="https://en.wikipedia.org/wiki/SOLID">SOLID</a>
    principles of object-oriented design.<br />

    Create <code>ChildAccount</code> and <code>TransferAccount</code> classes.
    The former must override (<code>virtual</code>!) the
    <code>withdraw(.)</code> function because children are not allowed to
    overdraw their accounts. The latter must implement an additional method
    that allows the transfer accounts to transfer money to other accounts.
    <br />

    All classes must be implemented in separate header files. Also,
    each class must
    have a separate <kbd>cpp</kbd> file for implementing the new / changed
    methods.
    Your implementation must be done inside of a <kbd>bank</kbd> namespace.
    Use all three
    <code>Account</code> types in this mini-project's <kbd>main.cpp</kbd> file:
    <ul>
      <li>create at least two accounts per type</li>
      <li>perform multiple deposits and withdrawals</li>
      <li>try to overdraw a child account</li>
      <li>transfer money to each account type</li>
      <li>display the final balance of all accounts</li>
    </ul>
    Provide a <kbd>Makefile</kbd> that compiles the project.<br />

    Follow the specification in the class diagram below:<br />
    <img src="/images/uml/accounts.svg" alt="[Bank Accounts Class Diagram]">
    <br />
    The <code>withdraw(.)</code> method of the <code>ChildAccount</code>
    must allow withdrawals up to the current balance of the account.
    If someone tries to withdraw more money, issue a warning on
    <code>stderr</code> and only limit the amount paid out to the current
    balance. The actual amount withdrawn is returned to the caller.

    <br />
    Reminder: the amounts are stored as integral numbers to avoid problems with
    floating point precision. The amount stored in the balance represents
    cents.
  </li>

</ol>
